%define nptl_arches %{ix86} alpha ia64 ppc s390 s390x x86_64

# compatibility with legacy versions of rpm
%{!?_lib:%define _lib	lib}

%define	__soversion	4.3
%define	_libdb_a	libdb-%{__soversion}.a
%define	_libcxx_a	libdb_cxx-%{__soversion}.a

Summary:	The Berkeley DB database library (version 4) for C.
Name:		db4
Version:	4.3.28
Release:	1
Source0:	ftp://ftp.sleepycat.com/releases/db-%{version}.tar.gz
Source1:	http://www.sleepycat.com/update/1.85/db.1.85.tar.gz
Source2:	nptl-abi-note.S
Patch00:	db-4.3.21-java.patch
Patch01:	db-4.2.52-gcj.patch
Patch02:	db-4.3.28-no-ed-gd-1.diff
Patch10:	http://www.sleepycat.com/update/1.85/patch.1.1
Patch11:	http://www.sleepycat.com/update/1.85/patch.1.2
Patch12:	http://www.sleepycat.com/update/1.85/patch.1.3
Patch13:	http://www.sleepycat.com/update/1.85/patch.1.4
Patch14:	db-1.85-errno.patch
License:	GPL
Group:		System Environment/Libraries
Obsoletes:	db1, db1-devel, db2, db3
BuildPreReq:	perl
BuildRoot:	%{_tmppath}/%{name}-%{release}-root

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. The Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. The Berkeley DB supports C, C++, Java, and Perl APIs. It is
used by many applications, including Python and Perl, so this should
be installed on all systems.

%files
  %defattr(-,root,root)
  %doc LICENSE README docs/images

  /%{_lib}/libdb-%{__soversion}.so
  %{_libdir}/libdb-%{__soversion}.so
  %{_libdir}/libdb_cxx-%{__soversion}.so
%ifarch %{nptl_arches}
%ifarch %{ix86}
  /%{_lib}/tls/*/libdb-%{__soversion}.so
  %{_libdir}/tls/*/libdb-%{__soversion}.so
  %{_libdir}/tls/*/libdb_cxx-%{__soversion}.so
%else
  /%{_lib}/tls/libdb-%{__soversion}.so
  %{_libdir}/tls/libdb-%{__soversion}.so
  %{_libdir}/tls/libdb_cxx-%{__soversion}.so
%endif
%endif

%package utils
Summary:	Command line tools for managing Berkeley DB (version 4) databases.
Group:		Applications/Databases
Requires:	db4 = %{version}-%{release}
Obsoletes:	db2-utils, db3-utils

%description utils
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. DB supports C, C++, Java and Perl APIs.

%files utils
  %defattr(-,root,root)
  %doc	docs/utility

  %{_bindir}/berkeley_db*_svc
  %{_bindir}/db*_archive
  %{_bindir}/db*_checkpoint
  %{_bindir}/db*_deadlock
  %{_bindir}/db*_dump*
  %{_bindir}/db*_load
  %{_bindir}/db*_printlog
  %{_bindir}/db*_recover
  %{_bindir}/db*_stat
  %{_bindir}/db*_upgrade
  %{_bindir}/db*_verify

%package devel
Summary:	Development files for the Berkeley DB (version 4) library.
Group:		System Environment/Libraries
Requires:	db4 = %{version}-%{release}
Obsoletes:	db2-devel, db3-devel

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. This package contains the header files,
libraries, and documentation for building programs which use the
Berkeley DB.

%files devel
  %defattr(-,root,root)
  %doc	docs/api_c docs/api_cxx docs/index.html
  %doc	docs/ref docs/sleepycat
  %doc	examples_c examples_cxx

  %{_libdir}/libdb.so
  %{_libdir}/libdb_cxx.so
  %{_libdir}/libdb-%{__soversion}.la
  %{_libdir}/libdb-4.so
  %{_libdir}/libdb_cxx-%{__soversion}.la
  %{_libdir}/libdb_cxx-4.so
  %{_libdir}/%{_libdb_a}
  %{_libdir}/%{_libcxx_a}
  %{_includedir}/%{name}
  %{_includedir}/*.h

%prep
%setup -q -n db-%{version} -a 1
%patch00 -p1
%patch01 -p1
%patch02 -p1

  pushd dist
    libtoolize --copy --force
    cp -f %{_datadir}/aclocal/libtool.m4 aclocal/libtool.ac
  popd

  pushd db.1.85/PORT/linux
%patch10 -p0
  popd

  pushd db.1.85
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p1
  popd

  # Remove tags files which we don't need.
  find . -name tags | xargs rm -f

  # Define a shell function for fixing HREF references in the docs, which
  # would otherwise break when we split the docs up into subpackages.
  fixup_href() {
    for doc in $@ ; do
        chmod u+w ${doc}
        sed -e 's,="../api_c/,="../../%{name}-devel-%{version}/api_c/,g' \
            -e 's,="api_c/,="../%{name}-devel-%{version}/api_c/,g' \
            -e 's,="../api_cxx/,="../../%{name}-devel-%{version}/api_cxx/,g' \
            -e 's,="api_cxx/,="../%{name}-devel-%{version}/api_cxx/,g' \
            -e 's,="../api_java/,="../../%{name}-devel-%{version}/api_java/,g' \
            -e 's,="api_java/,="../%{name}-devel-%{version}/api_java/,g' \
            -e 's,="../api_tcl/,="../../%{name}-devel-%{version}/api_tcl/,g' \
            -e 's,="api_tcl/,="../%{name}-devel-%{version}/api_tcl/,g' \
            -e 's,="../examples_c/,="../../%{name}-devel-%{version}/examples_c/,g' \
            -e 's,="examples_c/,="../%{name}-devel-%{version}/examples_c/,g' \
            -e 's,="../examples_cxx/,="../../%{name}-devel-%{version}/examples_cxx/,g' \
            -e 's,="examples_cxx/,="../%{name}-devel-%{version}/examples_cxx/,g' \
            -e 's,="../ref/,="../../%{name}-devel-%{version}/ref/,g' \
            -e 's,="ref/,="../%{name}-devel-%{version}/ref/,g' \
            -e 's,="../sleepycat/,="../../%{name}-devel-%{version}/sleepycat/,g' \
            -e 's,="sleepycat/,="../%{name}-devel-%{version}/sleepycat/,g' \
            -e 's,="../images/,="../../%{name}-%{version}/images/,g' \
            -e 's,="images/,="../%{name}-%{version}/images/,g' \
            -e 's,="../utility/,="../../%{name}-%{version}/utility/,g' \
            -e 's,="utility/,="../%{name}-%{version}/utility/,g' ${doc} > ${doc}.new
        touch -r ${doc} ${doc}.new
        cat ${doc}.new > ${doc}
        touch -r ${doc}.new ${doc}
        rm -f ${doc}.new
    done
  }

  set +x	# XXX painful to watch
  # Fix all of the HTML files.
  fixup_href `find . -name "*.html"`
  set -x	# XXX painful to watch

  cd dist
  ./s_config

%build
  export CFLAGS="$RPM_OPT_FLAGS"

  # Build the old db-185 libraries.
  make -C db.1.85/PORT/%{_os} OORG="$CFLAGS"

  #
  # XXX
  #
  build() {
	test -d dist/$1 || mkdir dist/$1

	# Static link db_dump185 with old db-185 libraries.
	/bin/sh libtool --mode=compile %{__cc} $RPM_OPT_FLAGS -Idb.1.85/PORT/%{_os}/include -D_REENTRANT -c db_dump185/db_dump185.c -o dist/$1/db_dump185.lo
	/bin/sh libtool --mode=link    %{__cc} -o dist/$1/db_dump185 dist/$1/db_dump185.lo db.1.85/PORT/%{_os}/libdb.a

	pushd dist/$1
	# Force the threading model used, for selecting whether or not we will
	# depend on NPTL-specific features.
	echo ${2:+db_cv_mutex=$2} > config.cache
	if test -n "$nptl_lo" ; then
		/bin/sh libtool --mode=compile %{__cc} $RPM_OPT_FLAGS \
			-o $nptl_lo -c $nptl_s
	fi
	ln -sf ../configure .
	# XXX --enable-diagnostic should be disabled for production (but is
	# useful).
	# XXX --enable-debug_{r,w}op should be disabled for production.
	%configure -C \
		--enable-compat185 \
		--enable-dump185 \
		--enable-shared \
		--enable-static \
		--enable-rpc \
		--disable-tcl \
		--enable-cxx \
		--disable-java \
		# --enable-test \
		# --enable-diagnostic \
		# --enable-debug --enable-debug_rop --enable-debug_wop \

	# Remove libtool predep_objects and postdep_objects wonkiness so that
	# building without -nostdlib doesn't include them twice.  Because we
	# already link with g++, weird stuff happens if you don't let the
	# compiler handle this.
	perl -pi -e 's/^predep_objects=".*$/predep_objects=""/' libtool
	perl -pi -e 's/^postdep_objects=".*$/postdep_objects=""/' libtool
	perl -pi -e 's/-shared -nostdlib/-shared/' libtool

#	make libdb=%{_libdb_a} libcxx=%{_libcxx_a} %{?_smp_mflags} \
	make                                       %{?_smp_mflags} \
		LIBSO_LIBS='$(LIBS)'" $nptl_lo" \
		LIBXSO_LIBS='$(LIBS)'" $nptl_lo" \
		LIBJSO_LIBS='$(LIBS)'" $nptl_lo" \
		LIBTSO_LIBS='$(LIBS)'" $nptl_lo"

	# XXX hack around libtool not creating ./libs/libdb_java-X.Y.lai
	LDBJ=./.libs/libdb_java-%{__soversion}.la
	if test -f ${LDBJ} -a ! -f ${LDBJ}i; then
		sed -e 's,^installed=no,installed=yes,' < ${LDBJ} > ${LDBJ}i
	fi

popd
}

%ifarch %{nptl_arches}
  unset nptl_s nptl_lo
  case %{_os} in
  linux|Linux)
	nptl_s=%{SOURCE2}
	nptl_lo=nptl-abi-note.lo
        ;;
  esac

  build dist-tls POSIX/pthreads/library
  unset nptl_s nptl_lo
%endif

  build dist-notls POSIX/pthreads/library/private

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
  mkdir -p ${RPM_BUILD_ROOT}%{_libdir}

%ifarch %{nptl_arches}
  %makeinstall -C dist/dist-tls

  # XXX Nuke non-versioned archives.
  rm -f $RPM_BUILD_ROOT/%{_libdir}/{libdb.a,libdb_cxx.a}

  chmod +x $RPM_BUILD_ROOT/%{_libdir}/*.so*
  mkdir -p ${RPM_BUILD_ROOT}{/%{_lib},%{_libdir}}/tls
  mv $RPM_BUILD_ROOT/%{_libdir}/libdb*%{__soversion}.so $RPM_BUILD_ROOT/%{_libdir}/tls/
%endif

  %makeinstall -C dist/dist-notls

  # XXX Nuke non-versioned archives.
  rm -f $RPM_BUILD_ROOT/%{_libdir}/{libdb.a,libdb_cxx.a}

  chmod +x $RPM_BUILD_ROOT/%{_libdir}/*.so*

  # Move the main shared library to lib directory, but leave the
  # unversioned .so symlink in the usual place to link against.
  if [ "%{_libdir}" != "/%{_lib}" ]; then
	# Move the non-tls library.
	mv $RPM_BUILD_ROOT/%{_libdir}/libdb-%{__soversion}.so $RPM_BUILD_ROOT/%{_lib}/

	# Move the tls library, if we have one.
	mkdir -p $RPM_BUILD_ROOT/%{_lib}/tls
	if test -e $RPM_BUILD_ROOT/%{_libdir}/tls/libdb-%{__soversion}.so ; then
		mv $RPM_BUILD_ROOT/%{_libdir}/tls/libdb-%{__soversion}.so $RPM_BUILD_ROOT/%{_lib}/tls/
	fi

	# Leave relative symlinks in %{_libdir}.
	touch $RPM_BUILD_ROOT/rootfile
	root=..
	while [ ! -e $RPM_BUILD_ROOT/%{_libdir}/${root}/rootfile ] ; do
		root=${root}/..
	done
	rm $RPM_BUILD_ROOT/rootfile
	ln -sf ${root}/%{_lib}/libdb-%{__soversion}.so $RPM_BUILD_ROOT/%{_libdir}/libdb.so
	ln -sf ${root}/%{_lib}/libdb-%{__soversion}.so $RPM_BUILD_ROOT/%{_libdir}/
	ln -sf libdb_cxx-%{__soversion}.so $RPM_BUILD_ROOT/%{_libdir}/libdb_cxx.so

	# Leave relative symlinks in %{_libdir}/tls.
	if test -e $RPM_BUILD_ROOT/%{_lib}/tls/libdb-%{__soversion}.so ; then
		ln -sf ${root}/../%{_lib}/tls/libdb-%{__soversion}.so $RPM_BUILD_ROOT/%{_libdir}/tls/
	fi
  fi

  # Move the x86 libraries into platform-specific subdirectories so that the
  # tls-enabled glibc doesn't try to use NPTL-dependent libdb on real i386s,
  # because it doesn't provide an NPTL libpthread for that platform.
%ifarch %{ix86}
  case %{_target_platform} in
    i386*|i486*) arches="i486 i586 i686";;
    i586*) arches="i586 i686";;
    i686*) arches="i686";;
    athlon*) arches="athlon";;
    *) arches=%{_target_cpu};;
  esac

  # "Move" the libraries by linking them.
  for targetarch in $arches ; do
    mkdir -p $RPM_BUILD_ROOT/%{_libdir}/tls/${targetarch}
    ln $RPM_BUILD_ROOT/%{_libdir}/tls/lib* $RPM_BUILD_ROOT/%{_libdir}/tls/${targetarch}/
    if [ "%{_libdir}" != "/%{_lib}" ]; then
        mkdir -p $RPM_BUILD_ROOT/%{_lib}/tls/${targetarch}
        ln $RPM_BUILD_ROOT/%{_lib}/tls/lib* $RPM_BUILD_ROOT/%{_lib}/tls/${targetarch}/
    fi
  done

  rm $RPM_BUILD_ROOT/{%{_lib},%{_libdir}}/tls/lib*

  # Now fix the symlinks.
  if [ "%{_libdir}" != "/%{_lib}" ]; then
    # In with the new.
    for targetarch in $arches ; do
      mkdir -p $RPM_BUILD_ROOT/%{_libdir}/tls/${targetarch}
      ln -sf ${root}/../../%{_lib}/tls/${targetarch}/libdb-%{__soversion}.so $RPM_BUILD_ROOT/%{_libdir}/tls/${targetarch}/
    done
  fi
%endif

  # Move the header files to a subdirectory, in case we're deploying on a
  # system with multiple versions of DB installed.
  mkdir -p $RPM_BUILD_ROOT/%{_includedir}/db4
  mv $RPM_BUILD_ROOT/%{_includedir}/*.h $RPM_BUILD_ROOT/%{_includedir}/db4/

  # Create symlinks to includes so that "use <db.h> and link with -ldb" works.
  for i in db.h db_cxx.h db_185.h; do
    ln -s db4/$i $RPM_BUILD_ROOT%{_includedir}
  done

  # Remove unpackaged files.
  rm -rf ${RPM_BUILD_ROOT}%{_prefix}/docs

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.3.28, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
